/* Auto-generated by genmsg_cpp for file /home/east/ros_workspace/TestNode/srv/Execute.srv */
#ifndef TESTNODE_SERVICE_EXECUTE_H
#define TESTNODE_SERVICE_EXECUTE_H
#include <string>
#include <vector>
#include <map>
#include <ostream>
#include "ros/serialization.h"
#include "ros/builtin_message_traits.h"
#include "ros/message_operations.h"
#include "ros/time.h"

#include "ros/macros.h"

#include "ros/assert.h"

#include "ros/service_traits.h"




namespace TestNode
{
template <class ContainerAllocator>
struct ExecuteRequest_ {
  typedef ExecuteRequest_<ContainerAllocator> Type;

  ExecuteRequest_()
  : program()
  {
  }

  ExecuteRequest_(const ContainerAllocator& _alloc)
  : program(_alloc)
  {
  }

  typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _program_type;
  std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  program;


  typedef boost::shared_ptr< ::TestNode::ExecuteRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::TestNode::ExecuteRequest_<ContainerAllocator>  const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;
}; // struct ExecuteRequest
typedef  ::TestNode::ExecuteRequest_<std::allocator<void> > ExecuteRequest;

typedef boost::shared_ptr< ::TestNode::ExecuteRequest> ExecuteRequestPtr;
typedef boost::shared_ptr< ::TestNode::ExecuteRequest const> ExecuteRequestConstPtr;


template <class ContainerAllocator>
struct ExecuteResponse_ {
  typedef ExecuteResponse_<ContainerAllocator> Type;

  ExecuteResponse_()
  {
  }

  ExecuteResponse_(const ContainerAllocator& _alloc)
  {
  }


  typedef boost::shared_ptr< ::TestNode::ExecuteResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::TestNode::ExecuteResponse_<ContainerAllocator>  const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;
}; // struct ExecuteResponse
typedef  ::TestNode::ExecuteResponse_<std::allocator<void> > ExecuteResponse;

typedef boost::shared_ptr< ::TestNode::ExecuteResponse> ExecuteResponsePtr;
typedef boost::shared_ptr< ::TestNode::ExecuteResponse const> ExecuteResponseConstPtr;

struct Execute
{

typedef ExecuteRequest Request;
typedef ExecuteResponse Response;
Request request;
Response response;

typedef Request RequestType;
typedef Response ResponseType;
}; // struct Execute
} // namespace TestNode

namespace ros
{
namespace message_traits
{
template<class ContainerAllocator> struct IsMessage< ::TestNode::ExecuteRequest_<ContainerAllocator> > : public TrueType {};
template<class ContainerAllocator> struct IsMessage< ::TestNode::ExecuteRequest_<ContainerAllocator>  const> : public TrueType {};
template<class ContainerAllocator>
struct MD5Sum< ::TestNode::ExecuteRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "4ad450bef4dba40eb1ebd9fe8a5face8";
  }

  static const char* value(const  ::TestNode::ExecuteRequest_<ContainerAllocator> &) { return value(); } 
  static const uint64_t static_value1 = 0x4ad450bef4dba40eULL;
  static const uint64_t static_value2 = 0xb1ebd9fe8a5face8ULL;
};

template<class ContainerAllocator>
struct DataType< ::TestNode::ExecuteRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "TestNode/ExecuteRequest";
  }

  static const char* value(const  ::TestNode::ExecuteRequest_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct Definition< ::TestNode::ExecuteRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "string program\n\
\n\
";
  }

  static const char* value(const  ::TestNode::ExecuteRequest_<ContainerAllocator> &) { return value(); } 
};

} // namespace message_traits
} // namespace ros


namespace ros
{
namespace message_traits
{
template<class ContainerAllocator> struct IsMessage< ::TestNode::ExecuteResponse_<ContainerAllocator> > : public TrueType {};
template<class ContainerAllocator> struct IsMessage< ::TestNode::ExecuteResponse_<ContainerAllocator>  const> : public TrueType {};
template<class ContainerAllocator>
struct MD5Sum< ::TestNode::ExecuteResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "d41d8cd98f00b204e9800998ecf8427e";
  }

  static const char* value(const  ::TestNode::ExecuteResponse_<ContainerAllocator> &) { return value(); } 
  static const uint64_t static_value1 = 0xd41d8cd98f00b204ULL;
  static const uint64_t static_value2 = 0xe9800998ecf8427eULL;
};

template<class ContainerAllocator>
struct DataType< ::TestNode::ExecuteResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "TestNode/ExecuteResponse";
  }

  static const char* value(const  ::TestNode::ExecuteResponse_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct Definition< ::TestNode::ExecuteResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "\n\
\n\
";
  }

  static const char* value(const  ::TestNode::ExecuteResponse_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator> struct IsFixedSize< ::TestNode::ExecuteResponse_<ContainerAllocator> > : public TrueType {};
} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

template<class ContainerAllocator> struct Serializer< ::TestNode::ExecuteRequest_<ContainerAllocator> >
{
  template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
  {
    stream.next(m.program);
  }

  ROS_DECLARE_ALLINONE_SERIALIZER;
}; // struct ExecuteRequest_
} // namespace serialization
} // namespace ros


namespace ros
{
namespace serialization
{

template<class ContainerAllocator> struct Serializer< ::TestNode::ExecuteResponse_<ContainerAllocator> >
{
  template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
  {
  }

  ROS_DECLARE_ALLINONE_SERIALIZER;
}; // struct ExecuteResponse_
} // namespace serialization
} // namespace ros

namespace ros
{
namespace service_traits
{
template<>
struct MD5Sum<TestNode::Execute> {
  static const char* value() 
  {
    return "4ad450bef4dba40eb1ebd9fe8a5face8";
  }

  static const char* value(const TestNode::Execute&) { return value(); } 
};

template<>
struct DataType<TestNode::Execute> {
  static const char* value() 
  {
    return "TestNode/Execute";
  }

  static const char* value(const TestNode::Execute&) { return value(); } 
};

template<class ContainerAllocator>
struct MD5Sum<TestNode::ExecuteRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "4ad450bef4dba40eb1ebd9fe8a5face8";
  }

  static const char* value(const TestNode::ExecuteRequest_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct DataType<TestNode::ExecuteRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "TestNode/Execute";
  }

  static const char* value(const TestNode::ExecuteRequest_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct MD5Sum<TestNode::ExecuteResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "4ad450bef4dba40eb1ebd9fe8a5face8";
  }

  static const char* value(const TestNode::ExecuteResponse_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct DataType<TestNode::ExecuteResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "TestNode/Execute";
  }

  static const char* value(const TestNode::ExecuteResponse_<ContainerAllocator> &) { return value(); } 
};

} // namespace service_traits
} // namespace ros

#endif // TESTNODE_SERVICE_EXECUTE_H

